BEGIN;

-- issue2584: Prozentuale Verteilung
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1.2/04_prozentuale_verteilung.sql', current_timestamp);

-- Start, disable triggers and set role
ALTER TABLE master_tbl DISABLE TRIGGER USER;
SET ROLE :db_adm;


-- Drop the master view before adding a new column, then recreate everything
-- back that depended on it


DROP VIEW master_tbl_view CASCADE;

-- Löschvorgang löscht ebenfalls Regel _RETURN für Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_anonym_insert_rule für Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_anonym_delete_rule für Sicht master_tbl_anonym_view


-- New field with foreign key
ALTER TABLE master_tbl DROP COLUMN verteilung_aa_betreuung CASCADE;
-- Löschvorgang löscht ebenfalls Regel _RETURN für Sicht master_tbl_view
-- Löschvorgang löscht ebenfalls Sicht master_tbl_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_insert_rule für Sicht master_tbl_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_delete_rule für Sicht master_tbl_view
-- Löschvorgang löscht ebenfalls Regel _RETURN für Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_anonym_insert_rule für Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Regel master_tbl_anonym_delete_rule für Sicht master_tbl_anonym_view
-- Löschvorgang löscht ebenfalls Regel _RETURN für Sicht master_tbl_eval_total_view
-- Löschvorgang löscht ebenfalls Sicht master_tbl_eval_total_view
-- Löschvorgang löscht ebenfalls Regel _RETURN für Sicht master_tbl_eval_incm_view
-- Löschvorgang löscht ebenfalls Sicht master_tbl_eval_incm_view

ALTER TABLE master_tbl DROP COLUMN verteilung_aa_oeffentlichkeit;
ALTER TABLE master_tbl DROP COLUMN verteilung_aa_evaluation;
ALTER TABLE master_tbl DROP COLUMN verteilung_aa_freiwilligenarbeit;
ALTER TABLE master_tbl DROP COLUMN verteilung_aa_leitung;


CREATE OR REPLACE VIEW master_tbl_view
AS SELECT 
     master_tbl.id AS id,
     master_tbl.uuid_id AS uuid_id,
     master_tbl.bearbeiter_id AS bearbeiter_id,
     master_tbl.fkz AS fkz,
     master_tbl.phase AS phase,
     master_tbl.datum_begin_zeitraum AS datum_begin_zeitraum,
     master_tbl.datum_ende_zeitraum AS datum_ende_zeitraum,
     master_tbl.raeumliche_zustaendigkeit AS raeumliche_zustaendigkeit,
     master_tbl.raeumliche_zustaendigkeit_nennung AS raeumliche_zustaendigkeit_nennung,
     master_tbl.nennung_zustaendigkeit AS nennung_zustaendigkeit,
     master_tbl.jmdstruktur AS jmdstruktur,
     master_tbl.traeger_integrationskurs AS traeger_integrationskurs,
     master_tbl.anzahl_ha_stellenteile AS anzahl_ha_stellenteile,
     master_tbl.anzahl_ha_personen AS anzahl_ha_personen,
     master_tbl.anzahl_ha_maennlich AS anzahl_ha_maennlich,
     master_tbl.anzahl_ha_weiblich AS anzahl_ha_weiblich,
     master_tbl.anzahl_ha_migration AS anzahl_ha_migration,
     master_tbl.ha_sprachkenntnis_arabisch AS ha_sprachkenntnis_arabisch,
     master_tbl.ha_sprachkenntnis_englisch AS ha_sprachkenntnis_englisch,
     master_tbl.ha_sprachkenntnis_franzoesisch AS ha_sprachkenntnis_franzoesisch,
     master_tbl.ha_sprachkenntnis_polnisch AS ha_sprachkenntnis_polnisch,
     master_tbl.ha_sprachkenntnis_russisch AS ha_sprachkenntnis_russisch,
     master_tbl.ha_sprachkenntnis_spanisch AS ha_sprachkenntnis_spanisch,
     master_tbl.ha_sprachkenntnis_tuerkisch AS ha_sprachkenntnis_tuerkisch,
     master_tbl.ha_sprachkenntnis_sonstige AS ha_sprachkenntnis_sonstige,
     master_tbl.ha_sprachkenntnisse_sonstige_nennung AS ha_sprachkenntnisse_sonstige_nennung,
     master_tbl.verteilung_aa_begleitung_cm AS verteilung_aa_begleitung_cm,
     master_tbl.verteilung_aa_gruppenangebote AS verteilung_aa_gruppenangebote,
     master_tbl.verteilung_aa_netzwerkarbeit AS verteilung_aa_netzwerkarbeit,
     master_tbl.verteilung_aa_dokumentation AS verteilung_aa_dokumentation,
     master_tbl.verteilung_aa_elternarbeit AS verteilung_aa_elternarbeit,
     master_tbl.verteilung_aa_sonstiges AS verteilung_aa_sonstiges,
     master_tbl.verteilung_aa_sonstiges_nennung AS verteilung_aa_sonstiges_nennung,
     master_tbl.anzahl_nha_stellenteile AS anzahl_nha_stellenteile,
     master_tbl.anzahl_nha_personen AS anzahl_nha_personen,
     master_tbl.anzahl_nha_maennlich AS anzahl_nha_maennlich,
     master_tbl.anzahl_nha_weiblich AS anzahl_nha_weiblich,
     master_tbl.anzahl_nha_migration AS anzahl_nha_migration,
     master_tbl.anzahl_nha_stundenunfang AS anzahl_nha_stundenunfang,
     master_tbl.anzahl_ea_personen AS anzahl_ea_personen,
     master_tbl.anzahl_ea_maennlich AS anzahl_ea_maennlich,
     master_tbl.anzahl_ea_weiblich AS anzahl_ea_weiblich,
     master_tbl.anzahl_ea_migration AS anzahl_ea_migration,
     master_tbl.bildungsberatung_garantiefonds AS bildungsberatung_garantiefonds,
     master_tbl.bildungsberatung_beratungsfaelle AS bildungsberatung_beratungsfaelle,
     master_tbl.existenz_jugendhilfekonferenz AS existenz_jugendhilfekonferenz,
     master_tbl.teilnahme_jugenhilfekonferenz AS teilnahme_jugenhilfekonferenz,
     master_tbl.existenz_jugendkonferenz AS existenz_jugendkonferenz,
     master_tbl.teilnahme_jugenkonferenz AS teilnahme_jugenkonferenz,
     master_tbl.erstellung_netzwerkkarte AS erstellung_netzwerkkarte,
     master_tbl.mitarbeit_gremien AS mitarbeit_gremien,
     master_tbl.weiter_akt_art_interkulturell AS weiter_akt_art_interkulturell,
     master_tbl.weiter_akt_art_aufsuchende AS weiter_akt_art_aufsuchende,
     master_tbl.weiter_akt_art_eltern AS weiter_akt_art_eltern,
     master_tbl.weiter_akt_art_freiwilligerdienst AS weiter_akt_art_freiwilligerdienst,
     master_tbl.weiter_akt_art_sonstiges AS weiter_akt_art_sonstiges,
     master_tbl.weitere_akt_anzahl_informationsveranst AS weitere_akt_anzahl_informationsveranst,
     master_tbl.weitere_akt_anzahl_workshops AS weitere_akt_anzahl_workshops,
     master_tbl.weitere_akt_anzahl_trainings AS weitere_akt_anzahl_trainings,
     master_tbl.weitere_akt_anzahl_veroeffentlichungen AS weitere_akt_anzahl_veroeffentlichungen,
     master_tbl.weitere_akt_anzahl_referate AS weitere_akt_anzahl_referate,
     master_tbl.weitere_akt_anzahl_sonstiges AS weitere_akt_anzahl_sonstiges,
     master_tbl.elternberatung_anzahl AS elternberatung_anzahl,
     master_tbl.elternberatung_stunden AS elternberatung_stunden,
     master_tbl.weitere_akt_weitere_angaben AS weitere_akt_weitere_angaben,
     master_tbl.eingabe_vollstaendig AS eingabe_vollstaendig
FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    phase = NEW.phase,
    datum_begin_zeitraum = NEW.datum_begin_zeitraum,
    datum_ende_zeitraum = NEW.datum_ende_zeitraum,
    raeumliche_zustaendigkeit = NEW.raeumliche_zustaendigkeit,
    raeumliche_zustaendigkeit_nennung = NEW.raeumliche_zustaendigkeit_nennung,
    nennung_zustaendigkeit = NEW.nennung_zustaendigkeit,
    jmdstruktur = NEW.jmdstruktur,
    traeger_integrationskurs = NEW.traeger_integrationskurs,
    anzahl_ha_stellenteile = NEW.anzahl_ha_stellenteile,
    anzahl_ha_personen = NEW.anzahl_ha_personen,
    anzahl_ha_maennlich = NEW.anzahl_ha_maennlich,
    anzahl_ha_weiblich = NEW.anzahl_ha_weiblich,
    anzahl_ha_migration = NEW.anzahl_ha_migration,
    ha_sprachkenntnis_arabisch = NEW.ha_sprachkenntnis_arabisch,
    ha_sprachkenntnis_englisch = NEW.ha_sprachkenntnis_englisch,
    ha_sprachkenntnis_franzoesisch = NEW.ha_sprachkenntnis_franzoesisch,
    ha_sprachkenntnis_polnisch = NEW.ha_sprachkenntnis_polnisch,
    ha_sprachkenntnis_russisch = NEW.ha_sprachkenntnis_russisch,
    ha_sprachkenntnis_spanisch = NEW.ha_sprachkenntnis_spanisch,
    ha_sprachkenntnis_tuerkisch = NEW.ha_sprachkenntnis_tuerkisch,
    ha_sprachkenntnis_sonstige = NEW.ha_sprachkenntnis_sonstige,
    ha_sprachkenntnisse_sonstige_nennung = NEW.ha_sprachkenntnisse_sonstige_nennung,
    verteilung_aa_begleitung_cm = NEW.verteilung_aa_begleitung_cm,
    verteilung_aa_gruppenangebote = NEW.verteilung_aa_gruppenangebote,
    verteilung_aa_netzwerkarbeit = NEW.verteilung_aa_netzwerkarbeit,
    verteilung_aa_dokumentation = NEW.verteilung_aa_dokumentation,
    verteilung_aa_elternarbeit = NEW.verteilung_aa_elternarbeit,
    verteilung_aa_sonstiges = NEW.verteilung_aa_sonstiges,
    verteilung_aa_sonstiges_nennung = NEW.verteilung_aa_sonstiges_nennung,
    anzahl_nha_stellenteile = NEW.anzahl_nha_stellenteile,
    anzahl_nha_personen = NEW.anzahl_nha_personen,
    anzahl_nha_maennlich = NEW.anzahl_nha_maennlich,
    anzahl_nha_weiblich = NEW.anzahl_nha_weiblich,
    anzahl_nha_migration = NEW.anzahl_nha_migration,
    anzahl_nha_stundenunfang = NEW.anzahl_nha_stundenunfang,
    anzahl_ea_personen = NEW.anzahl_ea_personen,
    anzahl_ea_maennlich = NEW.anzahl_ea_maennlich,
    anzahl_ea_weiblich = NEW.anzahl_ea_weiblich,
    anzahl_ea_migration = NEW.anzahl_ea_migration,
    bildungsberatung_garantiefonds = NEW.bildungsberatung_garantiefonds,
    bildungsberatung_beratungsfaelle = NEW.bildungsberatung_beratungsfaelle,
    existenz_jugendhilfekonferenz = NEW.existenz_jugendhilfekonferenz,
    teilnahme_jugenhilfekonferenz = NEW.teilnahme_jugenhilfekonferenz,
    existenz_jugendkonferenz = NEW.existenz_jugendkonferenz,
    teilnahme_jugenkonferenz = NEW.teilnahme_jugenkonferenz,
    erstellung_netzwerkkarte = NEW.erstellung_netzwerkkarte,
    mitarbeit_gremien = NEW.mitarbeit_gremien,
    weiter_akt_art_interkulturell = NEW.weiter_akt_art_interkulturell,
    weiter_akt_art_aufsuchende = NEW.weiter_akt_art_aufsuchende,
    weiter_akt_art_eltern = NEW.weiter_akt_art_eltern,
    weiter_akt_art_freiwilligerdienst = NEW.weiter_akt_art_freiwilligerdienst,
    weiter_akt_art_sonstiges = NEW.weiter_akt_art_sonstiges,
    weitere_akt_anzahl_informationsveranst = NEW.weitere_akt_anzahl_informationsveranst,
    weitere_akt_anzahl_workshops = NEW.weitere_akt_anzahl_workshops,
    weitere_akt_anzahl_trainings = NEW.weitere_akt_anzahl_trainings,
    weitere_akt_anzahl_veroeffentlichungen = NEW.weitere_akt_anzahl_veroeffentlichungen,
    weitere_akt_anzahl_referate = NEW.weitere_akt_anzahl_referate,
    weitere_akt_anzahl_sonstiges = NEW.weitere_akt_anzahl_sonstiges,
    elternberatung_anzahl = NEW.elternberatung_anzahl,
    elternberatung_stunden = NEW.elternberatung_stunden,
    weitere_akt_weitere_angaben = NEW.weitere_akt_weitere_angaben,
    eingabe_vollstaendig = NEW.eingabe_vollstaendig
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    id,
    uuid_id,
    bearbeiter_id,
    fkz,
    phase,
    datum_begin_zeitraum,
    datum_ende_zeitraum,
    raeumliche_zustaendigkeit,
    raeumliche_zustaendigkeit_nennung,
    nennung_zustaendigkeit,
    jmdstruktur,
    traeger_integrationskurs,
    anzahl_ha_stellenteile,
    anzahl_ha_personen,
    anzahl_ha_maennlich,
    anzahl_ha_weiblich,
    anzahl_ha_migration,
    ha_sprachkenntnis_arabisch,
    ha_sprachkenntnis_englisch,
    ha_sprachkenntnis_franzoesisch,
    ha_sprachkenntnis_polnisch,
    ha_sprachkenntnis_russisch,
    ha_sprachkenntnis_spanisch,
    ha_sprachkenntnis_tuerkisch,
    ha_sprachkenntnis_sonstige,
    ha_sprachkenntnisse_sonstige_nennung,
    verteilung_aa_begleitung_cm,
    verteilung_aa_gruppenangebote,
    verteilung_aa_netzwerkarbeit,
    verteilung_aa_dokumentation,
    verteilung_aa_elternarbeit,
    verteilung_aa_sonstiges,
    verteilung_aa_sonstiges_nennung,
    anzahl_nha_stellenteile,
    anzahl_nha_personen,
    anzahl_nha_maennlich,
    anzahl_nha_weiblich,
    anzahl_nha_migration,
    anzahl_nha_stundenunfang,
    anzahl_ea_personen,
    anzahl_ea_maennlich,
    anzahl_ea_weiblich,
    anzahl_ea_migration,
    bildungsberatung_garantiefonds,
    bildungsberatung_beratungsfaelle,
    existenz_jugendhilfekonferenz,
    teilnahme_jugenhilfekonferenz,
    existenz_jugendkonferenz,
    teilnahme_jugenkonferenz,
    erstellung_netzwerkkarte,
    mitarbeit_gremien,
    weiter_akt_art_interkulturell,
    weiter_akt_art_aufsuchende,
    weiter_akt_art_eltern,
    weiter_akt_art_freiwilligerdienst,
    weiter_akt_art_sonstiges,
    weitere_akt_anzahl_informationsveranst,
    weitere_akt_anzahl_workshops,
    weitere_akt_anzahl_trainings,
    weitere_akt_anzahl_veroeffentlichungen,
    weitere_akt_anzahl_referate,
    weitere_akt_anzahl_sonstiges,
    elternberatung_anzahl,
    elternberatung_stunden,
    weitere_akt_weitere_angaben,
    eingabe_vollstaendig FROM master_tbl_view;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;



CREATE OR REPLACE VIEW master_tbl_eval_total_view
   AS SELECT
    m.id AS id,
    m.phase AS phase,
    m.datum_begin_zeitraum AS datum_begin_zeitraum,
    m.datum_ende_zeitraum AS datum_ende_zeitraum,
    m.raeumliche_zustaendigkeit AS raeumliche_zustaendigkeit,
    m.jmdstruktur AS jmdstruktur,
    m.traeger_integrationskurs AS traeger_integrationskurs,
    m.anzahl_ha_stellenteile AS anzahl_ha_stellenteile,
    m.anzahl_ha_personen AS anzahl_ha_personen,
    m.anzahl_ha_maennlich AS anzahl_ha_maennlich,
    m.anzahl_ha_weiblich AS anzahl_ha_weiblich,
    m.verteilung_aa_begleitung_cm AS verteilung_aa_begleitung_cm,
    m.verteilung_aa_gruppenangebote AS verteilung_aa_gruppenangebote,
    m.verteilung_aa_netzwerkarbeit AS verteilung_aa_netzwerkarbeit,
    m.verteilung_aa_dokumentation AS verteilung_aa_dokumentation,
    m.verteilung_aa_elternarbeit AS verteilung_aa_elternarbeit,
    m.verteilung_aa_sonstiges AS verteilung_aa_sonstiges,
    m.anzahl_nha_stellenteile AS anzahl_nha_stellenteile,
    m.anzahl_nha_personen AS anzahl_nha_personen,
    m.anzahl_nha_maennlich AS anzahl_nha_maennlich,
    m.anzahl_nha_weiblich AS anzahl_nha_weiblich,
    m.anzahl_nha_migration AS anzahl_nha_migration,
    m.anzahl_ea_personen AS anzahl_ea_personen,
    m.anzahl_ea_maennlich AS anzahl_ea_maennlich,
    m.anzahl_ea_weiblich AS anzahl_ea_weiblich,
    m.anzahl_ea_migration AS anzahl_ea_migration,
    m.bildungsberatung_garantiefonds AS bildungsberatung_garantiefonds,
    m.bildungsberatung_beratungsfaelle AS bildungsberatung_beratungsfaelle,
    m.existenz_jugendhilfekonferenz AS existenz_jugendhilfekonferenz,
    m.teilnahme_jugenhilfekonferenz AS teilnahme_jugenhilfekonferenz,
    m.existenz_jugendkonferenz AS existenz_jugendkonferenz,
    m.teilnahme_jugenkonferenz AS teilnahme_jugenkonferenz,
    m.erstellung_netzwerkkarte AS erstellung_netzwerkkarte,
    m.weitere_akt_anzahl_informationsveranst AS weitere_akt_anzahl_informationsveranst,
    m.weitere_akt_anzahl_trainings AS weitere_akt_anzahl_trainings,
    m.weitere_akt_anzahl_veroeffentlichungen AS weitere_akt_anzahl_veroeffentlichungen,
    m.weitere_akt_anzahl_referate AS weitere_akt_anzahl_referate,
    m.weitere_akt_anzahl_sonstiges AS weitere_akt_anzahl_sonstiges,
    m.elternberatung_anzahl AS elternberatung_anzahl,
    m.elternberatung_stunden AS elternberatung_stunden
   FROM master_tbl m JOIN ka_status_tbl s
       ON m.id = s.master_id
       WHERE
           s.status <> 3 AND
           (m.bearbeiter_id = (getuserid())::integer)
           OR pg_has_role('admin','MEMBER');
--
GRANT SELECT ON master_tbl_eval_total_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_eval_total_view TO GROUP :admin_group;



CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
    SELECT * FROM master_tbl_eval_total_view
        WHERE phase IN (1);

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_group;

CREATE OR REPLACE  VIEW master_tbl_incm_view AS
    SELECT * FROM master_tbl_view
        WHERE phase IN (1);

GRANT SELECT ON public.master_tbl_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_incm_view TO :admin_group;


-- Finish, re-enable the triggers
SET ROLE postgres;
ALTER TABLE master_tbl ENABLE TRIGGER ALL;

COMMIT;
--ROLLBACK;
