SET ROLE postgres;

-- The mpuls_revoke_connect function needs to have permissions to revoke
-- CONNECT privileges from a user role and therefore has to be owned by
-- adm_ka_owner. However, mpuls_role_adm has to be able to execute
-- mpuls_revoke_connect because it's used from mpuls_drop_role which is
-- a SECURITY DEFINER function owned by mpuls_role_adm.
--
-- Not doing this when creating a new database is the reason for several issues:
-- mpuls/issue5746, mpuls/issue5839, mpuls/issue5920
ALTER FUNCTION mpuls_revoke_connect(varchar, varchar) OWNER TO :adm_ka_owner;
GRANT EXECUTE ON FUNCTION  mpuls_revoke_connect(varchar, varchar)
   TO GROUP mpuls_role_adm;


SET ROLE :db_adm;
