BEGIN;
-- 1.0pre6 -> jmd-1.0pre7
-- Fügt neue Felder in die Fallakte ein

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('jmd-1.0pre7/01-datenmodell.sql', current_timestamp);

-- Issue1335
ALTER TABLE master_tbl ADD weitere_akt_anzahl_referate INTEGER;

-- Issue1339
ALTER TABLE rg_nichtkjp_gruppenangebote_tbl ADD nichtkjp_grp_weitere_angaben TEXT;
ALTER TABLE rg_kjp_gruppenangebote_tbl ADD kjp_grp_weitere_angaben TEXT;

-- Issue1337
ALTER TABLE master_tbl ADD verteilung_aa_leitung INTEGER;
ALTER TABLE master_tbl ADD verteilung_aa_elternarbeit INTEGER;
ALTER TABLE master_tbl ADD verteilung_aa_freiwilligenarbeit INTEGER;


-- Views
DROP VIEW master_tbl_view CASCADE;

CREATE OR REPLACE VIEW master_tbl_view
AS SELECT master_tbl.* FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    phase = NEW.phase,
    datum_begin_zeitraum = NEW.datum_begin_zeitraum,
    datum_ende_zeitraum = NEW.datum_ende_zeitraum,
    raeumliche_zustaendigkeit = NEW.raeumliche_zustaendigkeit,
    raeumliche_zustaendigkeit_nennung = NEW.raeumliche_zustaendigkeit_nennung,
    nennung_zustaendigkeit = NEW.nennung_zustaendigkeit,
    jmdstruktur = NEW.jmdstruktur,
    anzahl_ha_stellenteile = NEW.anzahl_ha_stellenteile,
    anzahl_ha_personen = NEW.anzahl_ha_personen,
    anzahl_ha_maennlich = NEW.anzahl_ha_maennlich,
    anzahl_ha_weiblich = NEW.anzahl_ha_weiblich,
    anzahl_ha_migration = NEW.anzahl_ha_migration,
    ha_sprachkenntnis_arabisch = NEW.ha_sprachkenntnis_arabisch,
    ha_sprachkenntnis_englisch = NEW.ha_sprachkenntnis_englisch,
    ha_sprachkenntnis_franzoesisch = NEW.ha_sprachkenntnis_franzoesisch,
    ha_sprachkenntnis_polnisch = NEW.ha_sprachkenntnis_polnisch,
    ha_sprachkenntnis_russisch = NEW.ha_sprachkenntnis_russisch,
    ha_sprachkenntnis_spanisch = NEW.ha_sprachkenntnis_spanisch,
    ha_sprachkenntnis_tuerkisch = NEW.ha_sprachkenntnis_tuerkisch,
    ha_sprachkenntnis_sonstige = NEW.ha_sprachkenntnis_sonstige,
    ha_sprachkenntnisse_sonstige_nennung = NEW.ha_sprachkenntnisse_sonstige_nennung,
    verteilung_aa_begleitung_cm = NEW.verteilung_aa_begleitung_cm,
    verteilung_aa_betreuung = NEW.verteilung_aa_betreuung,
    verteilung_aa_gruppenangebote = NEW.verteilung_aa_gruppenangebote,
    verteilung_aa_netzwerkarbeit = NEW.verteilung_aa_netzwerkarbeit,
    verteilung_aa_oeffentlichkeit = NEW.verteilung_aa_oeffentlichkeit,
    verteilung_aa_evaluation = NEW.verteilung_aa_evaluation,
    verteilung_aa_dokumentation = NEW.verteilung_aa_dokumentation,
    verteilung_aa_leitung = NEW.verteilung_aa_leitung,
    verteilung_aa_elternarbeit = NEW.verteilung_aa_elternarbeit,
    verteilung_aa_freiwilligenarbeit = NEW.verteilung_aa_freiwilligenarbeit,
    verteilung_aa_sonstiges = NEW.verteilung_aa_sonstiges,
    verteilung_aa_sonstiges_nennung = NEW.verteilung_aa_sonstiges_nennung,
    anzahl_nha_stellenteile = NEW.anzahl_nha_stellenteile,
    anzahl_nha_personen = NEW.anzahl_nha_personen,
    anzahl_nha_maennlich = NEW.anzahl_nha_maennlich,
    anzahl_nha_weiblich = NEW.anzahl_nha_weiblich,
    anzahl_nha_migration = NEW.anzahl_nha_migration,
    anzahl_nha_stundenunfang = NEW.anzahl_nha_stundenunfang,
    anzahl_ea_personen = NEW.anzahl_ea_personen,
    anzahl_ea_maennlich = NEW.anzahl_ea_maennlich,
    anzahl_ea_weiblich = NEW.anzahl_ea_weiblich,
    anzahl_ea_migration = NEW.anzahl_ea_migration,
    anzahl_gesamt_personen = NEW.anzahl_gesamt_personen,
    nennung_qualimanagement = NEW.nennung_qualimanagement,
    existenz_jugendhilfekonferenz = NEW.existenz_jugendhilfekonferenz,
    teilnahme_jugenhilfekonferenz = NEW.teilnahme_jugenhilfekonferenz,
    existenz_jugendkonferenz = NEW.existenz_jugendkonferenz,
    teilnahme_jugenkonferenz = NEW.teilnahme_jugenkonferenz,
    mitarbeit_gremien = NEW.mitarbeit_gremien,
    weiter_akt_art_interkulturell = NEW.weiter_akt_art_interkulturell,
    weiter_akt_art_aufsuchende = NEW.weiter_akt_art_aufsuchende,
    weiter_akt_art_eltern = NEW.weiter_akt_art_eltern,
    weiter_akt_art_freiwilligerdienst = NEW.weiter_akt_art_freiwilligerdienst,
    weiter_akt_art_sonstiges = NEW.weiter_akt_art_sonstiges,
    weitere_akt_anzahl_informationsveranst = NEW.weitere_akt_anzahl_informationsveranst,
    weitere_akt_anzahl_workshops = NEW.weitere_akt_anzahl_workshops,
    weitere_akt_anzahl_trainings = NEW.weitere_akt_anzahl_trainings,
    weitere_akt_anzahl_veroeffentlichungen = NEW.weitere_akt_anzahl_veroeffentlichungen,
    weitere_akt_anzahl_referate = NEW.weitere_akt_anzahl_referate,
    weitere_akt_anzahl_sonstiges = NEW.weitere_akt_anzahl_sonstiges
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    id,
    uuid_id,
    bearbeiter_id,
    fkz,
    phase,
    datum_begin_zeitraum,
    datum_ende_zeitraum,
    raeumliche_zustaendigkeit,
    raeumliche_zustaendigkeit_nennung,
    nennung_zustaendigkeit,
    jmdstruktur,
    anzahl_ha_stellenteile,
    anzahl_ha_personen,
    anzahl_ha_maennlich,
    anzahl_ha_weiblich,
    anzahl_ha_migration,
    ha_sprachkenntnis_arabisch,
    ha_sprachkenntnis_englisch,
    ha_sprachkenntnis_franzoesisch,
    ha_sprachkenntnis_polnisch,
    ha_sprachkenntnis_russisch,
    ha_sprachkenntnis_spanisch,
    ha_sprachkenntnis_tuerkisch,
    ha_sprachkenntnis_sonstige,
    ha_sprachkenntnisse_sonstige_nennung,
    verteilung_aa_begleitung_cm,
    verteilung_aa_betreuung,
    verteilung_aa_gruppenangebote,
    verteilung_aa_netzwerkarbeit,
    verteilung_aa_oeffentlichkeit,
    verteilung_aa_evaluation,
    verteilung_aa_dokumentation,
    verteilung_aa_leitung,
    verteilung_aa_elternarbeit,
    verteilung_aa_freiwilligenarbeit,
    verteilung_aa_sonstiges,
    verteilung_aa_sonstiges_nennung,
    anzahl_nha_stellenteile,
    anzahl_nha_personen,
    anzahl_nha_maennlich,
    anzahl_nha_weiblich,
    anzahl_nha_migration,
    anzahl_nha_stundenunfang,
    anzahl_ea_personen,
    anzahl_ea_maennlich,
    anzahl_ea_weiblich,
    anzahl_ea_migration,
    anzahl_gesamt_personen,
    nennung_qualimanagement,
    existenz_jugendhilfekonferenz,
    teilnahme_jugenhilfekonferenz,
    existenz_jugendkonferenz,
    teilnahme_jugenkonferenz,
    mitarbeit_gremien,
    weiter_akt_art_interkulturell,
    weiter_akt_art_aufsuchende,
    weiter_akt_art_eltern,
    weiter_akt_art_freiwilligerdienst,
    weiter_akt_art_sonstiges,
    weitere_akt_anzahl_informationsveranst,
    weitere_akt_anzahl_workshops,
    weitere_akt_anzahl_trainings,
    weitere_akt_anzahl_veroeffentlichungen,
    weitere_akt_anzahl_referate,
    weitere_akt_anzahl_sonstiges FROM master_tbl_view;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE  VIEW master_tbl_incm_view AS
    SELECT * FROM master_tbl_view
        WHERE phase IN (1);

GRANT SELECT ON public.master_tbl_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_incm_view TO :admin_group;

DROP VIEW rg_nichtkjp_gruppenangebote_tbl_view CASCADE;
DROP VIEW rg_kjp_gruppenangebote_tbl_view CASCADE;
CREATE OR REPLACE VIEW rg_kjp_gruppenangebote_tbl_view
AS SELECT rg_kjp_gruppenangebote_tbl.* FROM rg_kjp_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_kjp_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_kjp_gruppenangebote_tbl_view
DO INSTEAD UPDATE rg_kjp_gruppenangebote_tbl SET
    kjp_grp_art_angebot = NEW.kjp_grp_art_angebot,
    kjp_grp_anzahl_teilnehmer_maennlich = NEW.kjp_grp_anzahl_teilnehmer_maennlich,
    kjp_grp_anzahl_teilnehmer_weiblich = NEW.kjp_grp_anzahl_teilnehmer_weiblich,
    kjp_grp_alter = NEW.kjp_grp_alter,
    kjp_grp_weitere_angaben = NEW.kjp_grp_weitere_angaben
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_delete_rule AS ON DELETE TO rg_kjp_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_insert_rule AS ON INSERT TO rg_kjp_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_kjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_kjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_kjp_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_kjp_gruppenangebote_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    kjp_grp_art_angebot,
    kjp_grp_anzahl_teilnehmer_maennlich,
    kjp_grp_anzahl_teilnehmer_weiblich,
    kjp_grp_alter,
    kjp_grp_weitere_angaben FROM rg_kjp_gruppenangebote_tbl_view;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_kjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_kjp_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_kjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_kjp_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_kjp_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_nichtkjp_gruppenangebote_tbl_view
AS SELECT rg_nichtkjp_gruppenangebote_tbl.* FROM rg_nichtkjp_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_nichtkjp_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_nichtkjp_gruppenangebote_tbl_view
DO INSTEAD UPDATE rg_nichtkjp_gruppenangebote_tbl SET
    nichtkjp_grp_art_angebot = NEW.nichtkjp_grp_art_angebot,
    nichtkjp_grp_anzahl_teilnehmer_maennlich = NEW.nichtkjp_grp_anzahl_teilnehmer_maennlich,
    nichtkjp_grp_anzahl_teilnehmer_weiblich = NEW.nichtkjp_grp_anzahl_teilnehmer_weiblich,
    nichtkjp_grp_alter = NEW.nichtkjp_grp_alter,
    nichtkjp_grp_weitere_angaben = NEW.nichtkjp_grp_weitere_angaben
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_delete_rule AS ON DELETE TO rg_nichtkjp_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_insert_rule AS ON INSERT TO rg_nichtkjp_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_nichtkjp_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_nichtkjp_gruppenangebote_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    nichtkjp_grp_art_angebot,
    nichtkjp_grp_anzahl_teilnehmer_maennlich,
    nichtkjp_grp_anzahl_teilnehmer_weiblich,
    nichtkjp_grp_alter,
    nichtkjp_grp_weitere_angaben FROM rg_nichtkjp_gruppenangebote_tbl_view;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_nichtkjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_nichtkjp_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_nichtkjp_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_nichtkjp_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;
-- Finish
SET ROLE postgres;

COMMIT;
