-- Unify phases "Unbekannt" and "Eingangsdaten" (issue5520).

-- 1. Set the value of datum_ea_start where it's currently NULL.
--
-- A good guess is the date the entry in master_tbl was created which
-- can be taken from ka_status_tbl.erstellt. That may not be correct,
-- though, because it's not transferred from one DB to another if the
-- data is exported and imported via XML, in which case it's the date
-- the data were imported, not when they were created originally. We
-- need to compare it with other dates in master_tbl which, if set, must
-- always later than datum_ea_start. Therefore we set datum_ea_start to
-- the earliest date
UPDATE master_tbl m
   SET datum_ea_start = LEAST(m.datum_cm_start, m.datum_ber_start,
                              m.datum_cm_ende, m.datum_ber_ende,
                              (SELECT erstellt FROM ka_status_tbl s
                               WHERE s.master_id = m.id))
 WHERE datum_ea_start is NULL;

-- 2. Set phase to 0 (Eingangsdaten) whereever it is currently -1
-- (Unbekannt).
UPDATE master_tbl SET phase=0 WHERE phase=-1;
