-- mpuls/issue5412:
--   - Merge some language entries
--   - rename an entry
--   - add some new entries
--   - mark some entries as old

--
-- update existing cases
--

-- replace 2, 'Amharisch', with 8, 'Äthiopisch / Amharisch'
UPDATE master_tbl
   SET muttersprache = 8
 WHERE muttersprache = 2;
UPDATE master_tbl
   SET sprache_zuhause = 8
 WHERE sprache_zuhause = 2;
UPDATE rg_sprache_zuhause_weitere_tbl
   SET sprache_zuhause_weitere = 8
 WHERE sprache_zuhause_weitere = 2;
UPDATE rg_weitere_sprache_tbl
   SET kf_erg_weiteresprache_nennung = 8
 WHERE kf_erg_weiteresprache_nennung = 2;

-- replace 9, 'Azeri', with 6, 'Aserbaidschanisch / Azeri'.
UPDATE master_tbl
   SET muttersprache = 6
 WHERE muttersprache = 9;
UPDATE master_tbl
   SET sprache_zuhause = 6
 WHERE sprache_zuhause = 9;
UPDATE rg_sprache_zuhause_weitere_tbl
   SET sprache_zuhause_weitere = 6
 WHERE sprache_zuhause_weitere = 9;
UPDATE rg_weitere_sprache_tbl
   SET kf_erg_weiteresprache_nennung = 6
 WHERE kf_erg_weiteresprache_nennung = 9;


--
-- Update muttersprache_tbl
--

ALTER TABLE muttersprache_tbl
ALTER COLUMN value SET DATA TYPE VARCHAR(26);

UPDATE muttersprache_tbl
   SET value = 'Aserbaidschanisch / Azeri'
 WHERE id = 6;

UPDATE muttersprache_tbl
   SET value = 'Äthiopisch / Amharisch'
 WHERE id = 8;

UPDATE muttersprache_tbl
   SET value = 'Oromo'
 WHERE id = 24;

DELETE FROM muttersprache_tbl WHERE id in (2, 9);

INSERT INTO muttersprache_tbl (id, value) VALUES (120, 'Kotokoli / Tem');
INSERT INTO muttersprache_tbl (id, value) VALUES (121, 'Wolof');
INSERT INTO muttersprache_tbl (id, value) VALUES (122, 'Susu');
INSERT INTO muttersprache_tbl (id, value) VALUES (123, 'Mandinka');
INSERT INTO muttersprache_tbl (id, value) VALUES (124, 'Bambara');
INSERT INTO muttersprache_tbl (id, value) VALUES (125, 'Twi');
INSERT INTO muttersprache_tbl (id, value) VALUES (126, 'Assyrisch-Neuaramäisch');

--
-- Mark some entries as old
--

UPDATE muttersprache_tbl
   SET value = 'Ge''ez (alt)'
 WHERE id = 26;

UPDATE muttersprache_tbl
   SET value = 'Glagolitisch (alt)'
 WHERE id = 28;

UPDATE muttersprache_tbl
   SET value = 'Jawi (alt)'
 WHERE id = 40;

UPDATE muttersprache_tbl
   SET value = 'Kanarese (alt)'
 WHERE id = 43;

UPDATE muttersprache_tbl
   SET value = 'Lateinisch (alt)'
 WHERE id = 55;

UPDATE muttersprache_tbl
   SET value = 'Lihijanisch (alt)'
 WHERE id = 57;

UPDATE muttersprache_tbl
   SET value = 'Moabitisch (alt)'
 WHERE id = 66;

UPDATE muttersprache_tbl
   SET value = 'Nabatäisch (alt)'
 WHERE id = 69;

UPDATE muttersprache_tbl
   SET value = 'Safatenisch (alt)'
 WHERE id = 82;

UPDATE muttersprache_tbl
   SET value = 'Sanskrit (alt)'
 WHERE id = 84;

UPDATE muttersprache_tbl
   SET value = 'Südarabisch (alt)'
 WHERE id = 94;

UPDATE muttersprache_tbl
   SET value = 'Tamudisch (alt)'
 WHERE id = 97;

UPDATE muttersprache_tbl
   SET value = 'Ugaritisch (alt)'
 WHERE id = 105;
