## -*- coding: utf-8 -*-
import logging

import formencode

from pylons import tmpl_context as c
from mpulsweb.lib.base import BaseController, render
from mpulsweb.lib.security import checkRole

log = logging.getLogger(__name__)


class TagsController(BaseController):

    @checkRole(('admin', 'cm'))
    def index(self, id):
        return self.overview(id)

    @checkRole(('admin', 'cm'))
    def overview(self, id):
        defaults = {'tags': []}
        id = self._checkInt(id)
        case = self._loadCase(id, read_only=True)
        c.tags = case.getTags()
        form = render('/tags/tags.mako')
        return formencode.htmlfill.render(form)

    @checkRole(('cm'))
    def editAction(self):
        pass
