## -*- coding: utf-8 -*-
<%def name="buildFormErrors(labels=None)">
  <% formular_labels = labels or {} %>
  % if len(c.form_errors) > 0:
    <div class="form_errors">
      <h1><a name="error_list">${_('Wrong formular input')}</a></h1>
      <ul>
        % for key, value in c.form_errors.iteritems():
          <li>${_(formular_labels.get(key, '%s' % key))}: ${value}</li>
        % endfor
      </ul>
    </div>
  % endif
</%def>

<%def name="title()">
    ${h.get_app_title()}
</%def>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">
<html>
  <head>
    <title>${self.title()}</title>
    <meta name="generator" content="vim">
    <meta name="author" content="Torsten Irlaender">
    <meta name="date" content="2007-08-07">
    <meta name="copyright" content="">
    <meta name="keywords" content="">
    <meta name="description" content="">
    <meta name="ROBOTS" content="NOINDEX, NOFOLLOW">
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <meta http-equiv="content-style-type" content="text/css">
    <meta http-equiv="expires" content="0">
    <link rel="shortcut icon" type="image/x-icon" href="${h.url('/images/mpuls.ico')}">
    % if c.print_version:
      <link href="${h.url('/styles/all.css')}" media="all" rel="stylesheet"
            type="text/css">
      <link href="${h.url('/styles/print.css')}" media="screen"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/printlocal.css')}" media="screen"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/print.css')}" media="print"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/printlocal.css')}" media="print"
            rel="stylesheet" type="text/css">
    % else:
      <link href="${h.url('/styles/all.css')}" media="all" rel="stylesheet"
            type="text/css">
      <link href="${h.url('/styles/screen.css')}" media="screen"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/widgets.css')}" media="all"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/print.css')}" media="print"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/menu.css')}" media="screen"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/tooltip.css')}" media="screen"
            rel="stylesheet" type="text/css">
      <link href="${h.url('/styles/local.css')}" media="all" rel="stylesheet"
            type="text/css">
      <link href="${h.url('/styles/bootstrap.css')}" media="all" rel="stylesheet"
            type="text/css">


      <!--[if IE 6]>
        <script defer type="text/javascript"
                src="${h.url('/js/ie6-png.js')}"></script>
        <script defer type="text/javascript"
                src="${h.url('/js/ie6-menu.js')}"></script>
        <link href  = "${h.url('/styles/ie6.css')}"
              media = "screen"
              rel   = "stylesheet" type="text/css">
      <![endif]-->
      <!--[if IE 7]>
        <link href  = "${h.url('/styles/ie7.css')}"
              media = "screen"
              rel   = "stylesheet" type="text/css">
      <![endif]-->
      <!--[if IE 8]>
        <link href  = "${h.url('/styles/ie8.css')}"
              media = "screen"
              rel   = "stylesheet" type="text/css">
      <![endif]-->
      <link href="${h.url('/styles/repair.css')}" media="screen"
            rel="stylesheet" type="text/css">
    % endif
    <script src="${h.url('/js/check.js')}" type="text/javascript"></script>
    <script src="${h.url('/js/jquery.js')}"></script>
    <script src="${h.url('/js/bootstrap.js')}"></script>
    <script src="${h.url('/js/toggleall.js')}"></script>
    % if c.conditional_form_info_url:
    <script src="${c.conditional_form_info_url}"></script>
    <script src="${h.url('/js/dynamicconds.js')}"></script>
    % endif
  </head>
  <body onload="clearModification();">
    % if g.mpuls_config.is_enabled('common', 'showdemonotice'):
    <div class="widget container" id="demonotice">
      ${h.literal(_('You are using a public demo installation of %s. Do not enter any real personal data! Please note, that all data will be deleted on server resets in regular intervals')) % h.get_app_title()}
    </div>
    % endif
    ${next.body()}
  </body>
</html>
