## -*- coding: utf-8 -*- 
<%inherit file="../../main.mako" />
<%def name="buildNavipath()">
	${parent.buildNavipath()}
	<li><a href="${h.url(controller='case', action='index')}">${_('Case Management')}</a></li>
	<li><a href="#">${_('Export case')}</a></li>
</%def>
<div class="dialog">
<h1><img src="${h.url('/images/icons/info/question.png')}" 
         alt="${_('attention')}"
         width="48"
         height="48">${c.dialog_title or c.confirm_for}</h1>
<form action="${h.url(controller='case_bundle', action='exportAction')}"
      method="GET">
<% case_bundle = session.get('casebundle') %>
% if case_bundle and len(case_bundle.case_list) > 1 and g.mpuls_config.is_enabled('offline-client', 'enabled'):
<h3>${_('Selected cases')}</h3>
    <p>
    ${_('<strong>Notice:</strong> You have selected more than one case document. The now created file cannot be used with the offline client at the moment. If you want to use the offline client, you need to select just one case document.')}
    </p>
% endif
<h3>${_('Exported parts of the case document')}</h3>
<p>${_('Please choose the exported pages of the case document:')}</p>
<ul>
  <input type="checkbox" name="mpuls-toggle-all-exportselection" id="all_pages"
         ><label for="all_pages">${_('Select/deselect all pages')}</label>

% for page in c.pages:
<% name = page.getName() %>
<li>
  <input type="checkbox" name="exportselection" value="${name}" id="${name}">
  <label for="${name}">${page.getDescription()}</label>
</li>
% endfor
</ul>
% if c.allow_logbook_export:
<ul>
  <li>
    <input type="checkbox" name="exportselection" value="logbook" id="logbook">
    <label for="logbook">${_('Logbook')}</label>
  </li>
</ul>
% endif
% if c.allow_documents_export:
<ul>
  <li>
    <input type="checkbox" name="exportselection" value="documents" id="documents">
    <label for="documents">${_("Documents")}</label>
  </li>
</ul>
% endif

% if g.mpuls_config.is_enabled('case-module', 'anonymize'):
  <h3>${_('Anonymisation')}</h3>
  <p>
  ${_('Please notice, that you export personal data, if you do not export with')} ${_('Export anonymisated data')}. ${_('You need to follow the data privacy.')}
  </p>
  <p>
    <input type="checkbox" name="exportanonym" id="exportanonym" value="1"> <label for="exportanonym">${_('Export anonymisated data')}<label>
  </p>
% else:
  <p>
  ${_('Please notice, that you export personal data.')} ${_('You need to follow the data privacy.')}
  </p>
% endif

<input type="hidden" name="exporttype" value="">
<input class="button" type="submit" value="${_('Download export')}">
</form>
</div>
