SET ROLE :adm_ka_owner;

BEGIN;
-- Tags

CREATE OR REPLACE VIEW tags_view
    AS SELECT
        id,
        label,
        description,
        systemtag
    FROM tags;

CREATE OR REPLACE RULE tags_update_rule
    AS ON UPDATE TO tags_view
    DO INSTEAD
        UPDATE tags SET
            label      = new.label,
            description = new.description,
            systemtag = new.systemtag
        WHERE tags.id = new.id;

CREATE OR REPLACE RULE tags_delete_rule
    AS ON DELETE TO  tags_view DO INSTEAD NOTHING;

CREATE OR REPLACE RULE tags_insert_rule
    AS ON INSERT TO tags_view DO INSTEAD NOTHING;


GRANT SELECT ON tags_view TO GROUP :cm_group;
GRANT UPDATE ON tags_view TO GROUP :cm_group;
GRANT SELECT ON tags_view TO GROUP :admin_group;
GRANT UPDATE ON tags_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_tags_cases_view
    AS SELECT
        id,
        master_id as case_id,
        tag_id,
        created
    FROM nm_tags_cases;

GRANT SELECT ON nm_tags_cases_view TO GROUP :cm_group;
GRANT UPDATE ON nm_tags_cases_view TO GROUP :cm_group;
GRANT SELECT ON nm_tags_cases_view TO GROUP :admin_group;
GRANT UPDATE ON nm_tags_cases_view TO GROUP :admin_group;

COMMIT;
