#!/bin/sh

# This script will check all databases for validity

TAGGINGCONFIG=${1-/var/lib/postgresql/tagging.xml}
PORT=${2-5432}
KALIST=${3-KA_list}
PREFIX=${4-} #DB prefix, e.g. "st" for JMD-structure part

TAGGINGEXEC=/usr/local/lib/libmpuls/mpulstags.py
USER=postgres

if [ ! -e $TAGGINGCONFIG ]; then
    echo "Could not find tagging-XML $TAGGINGCONFIG";
    exit;
fi

if [ ! -e $TAGGINGEXEC ]; then
    echo "Could not find tagging excutable $TAGGINGEXEC";
    exit;
fi

for KA in `cat $KALIST`
    do echo $PREFIX$KA;  python $TAGGINGEXEC -u $USER -d ka_${PREFIX}${KA}_db -p $PORT $TAGGINGCONFIG
done;

rm -f $KALIST
